<?php
/**
 * GMapFP! Openstreet Field Project
 * Version J3_1
 * Creation date: Novembre 2019
 * Author: Fabrice4821 - https://creation-web.pro
 * Author email: webmaster@gmapfp.org
 *
 * @copyright   Copyright (C) 2011 - 2019 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('_JEXEC') or die;

use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Plugin\PluginHelper;
use Joomla\Registry\Registry;

$value = $field->value;

if ($value == '')
{
	return;
}

// die(print_r($field));
// die(print_r($fieldParams));

$datas = explode(',', $field->rawvalue);
if (count($datas)>3) {
	$lat = $datas[0];
	$lng = $datas[1];
	$zoom = $datas[2];
	$lenth = strlen ($lat.$lng.$zoom)+3;
	$texte = str_replace('"', '\"', substr($field->rawvalue, $lenth));
} else {
	echo Text::_('PLG_FIELDS_GMAPFP_OPENSTREET_ERROR_DATAS');
	return;
}
				
$field->name = str_replace('-', '_', $field->name);
$targetid = 'jform_com_fields_' . $field->name;
$height = $fieldParams->get('mapheight');
$layers = '';
$baseLayers = array();
$aliasLayers = array();
$paramsLayers = $fieldParams->get('gmapfp_osm_layers');
$defaultLayer = '';
if ($paramsLayers)
	foreach($paramsLayers AS $layer){
		$layers .= 'var '.$layer->alias.' = L.tileLayer("'.$layer->url.'", {';
		$layers .= 'attribution: "'.str_replace(array('"','‹'), array('\"','<'), $layer->attribution).'",';
		$layers .= 'minZoom: 1,';
		$layers .= 'maxZoom: '.$layer->max_zoom.',';
		$layers .= 'id: "'.$layer->alias.'"';
		$layers .= '});';
		$layers .= 'mes_layers'.$field->name.'["'.$layer->alias.'"] = '.$layer->alias.';';
		$baseLayers[] = '"'.$layer->name.'":'.$layer->alias;
		$aliasLayers[] = $layer->alias;
	}
$var_baseLayers = 'var baseLayers'.$field->name.' = {'.implode(',', $baseLayers).'};';

if (in_array($fieldParams->get('gmapfp_type_admin_osm'), $aliasLayers))
	$defaultLayer = '';
elseif (array_key_exists(0, $aliasLayers))
	$defaultLayer = 'stylemap = "'.$aliasLayers[0].'";';
	
HTMLHelper::_('stylesheet', 'https://unpkg.com/leaflet/dist/leaflet.css');
HTMLHelper::_('script', 'https://unpkg.com/leaflet/dist/leaflet-src.js');

$js = ''
	.'var map'.$field->name.';'
	.'var marker1'.$field->name.';'
	.'var mes_layers'.$field->name.' = [];'
	.'var lat'.$field->name.' = '.$lat.';'
	.'var lng'.$field->name.' = '.$lng.';'
	.'var zoom'.$field->name.' = '.$zoom.';'
	.'var text'.$field->name.' = "'.$texte.'";'
	.''
	.'function init_osm() {'
	.'	var stylemap;'
	.''
	.$defaultLayer
	.''
	.$layers
	.''
	.'	var options = {'
	.'		center: [lat'.$field->name.', lng'.$field->name.'],'
	.'		zoom: zoom'.$field->name.','
	.'		layers: [mes_layers'.$field->name.'[stylemap]]'
	.'	};'
	.''
	.'	map'.$field->name.' = L.map("map_'.$targetid.'", options);'
	.''
	//affichce l'échelle
	.'	L.control.scale().addTo(map'.$field->name.');'
	.''
	.$var_baseLayers
	.''
	.'	L.control.layers(baseLayers'.$field->name.').addTo(map'.$field->name.');'
	.''
	// Create a draggable marker which will later on be binded to a'
	.'	marker1'.$field->name.' = L.marker([lat'.$field->name.', lng'.$field->name.'], {draggable: false}).addTo(map'.$field->name.');'
	.'	marker1'.$field->name.'.bindPopup("'.$texte.'");'."\r\n"
	.''
	.'}'
	.''
	// Register an event listener to fire when the page finishes loading
	.'jQuery( document ).ready(initialise_map_gmapfp'.$field->name.');'
	.''
	.'var tstGMapFP'.$field->name.';'
	.'var tstIntGMapFP'.$field->name.';'
	.''
	.'function CheckGMapFP'.$field->name.'() {'
	.'	if (tstGMapFP'.$field->name.') {'
	.'		if (tstGMapFP'.$field->name.'.offsetWidth != tstGMapFP'.$field->name.'.getAttribute("oldValue")) {'
	.'			tstGMapFP'.$field->name.'.setAttribute("oldValue",tstGMapFP'.$field->name.'.offsetWidth);'
	.'			init_osm();'
	.'		}'
	.'	}'
	.'}'
	.''
	.'function initialise_map_gmapfp'.$field->name.'() {'
	// Créer la div map
	.'	tstGMapFP'.$field->name.' = document.getElementById("map_'.$targetid.'");'
	.'  tstGMapFP'.$field->name.'.setAttribute("oldValue",0);'
	.'  tstIntGMapFP'.$field->name.' = setInterval("CheckGMapFP'.$field->name.'()",500);'
	.'}'
	.'';

Factory::getDocument()->addScriptDeclaration($js);

echo '<div style="height: '.$height.'px" id="map_' . $targetid . '"></div>';
